/* -----------------------------------------------------------------------------

  COPYIGHT

  1995  Dietmar  Eilert  (e-mail:  DIETMAR@TOMATE.TNG.OCHE.DE).  All  Rights
  Reserved.  Code  may not be reused/reproduced without written permission of
  the author.

  Dietmar Eilert
  Mies-v-d-Rohe-Str.31, 52074 Aachen, Germany
  E-Mail: DIETMAR@TOMATE.TNG.OCHE.DE
  Tel: +49-(0)241-81665
       +49-(0)2525-7776
  Fax: +49-(0)241-81665

  Example: scan handler looking for #defines. Scan handlers are plain functions 
  (LoadSeg'ed by GED): no standard C startup code, no library calls. 
  
  DICE-C:
  
  dcc define.c -// -l0 -md -mRR -o ram:defines

  ------------------------------------------------------------------------------
*/

#include <exec/types.h>

#define UPPER(a) ((a) & 95)

ULONG
ScanHandlerGuide(__D0 ULONG len, __A0 char **text, __A1 ULONG *line)
{
    const char *version = "$VER: Define 1.3 (16.6.95)";

    if (**text == '#') {

        if (len > 8) {

            UBYTE *next = *text + 1;

            if (UPPER(*next++) == 'D') {

                if (UPPER(*next++) == 'E') {

                    if (UPPER(*next++) == 'F') {

                        if (UPPER(*next++) == 'I') {

                            if (UPPER(*next++) == 'N') {

                                if (UPPER(*next++) == 'E') {

                                    if (*next++ == ' ') {

                                        UWORD letters = 0;

                                        for (len -= 8; (*next == 32) && len; --len)
                                            ++next;

                                        for (*text = next; len && (*next++ != ' '); --len)
                                            ++letters;

                                        return(letters);
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    return(FALSE);
}
